package mmrpwr;

import java.awt.event.*;
import java.awt.*;

import javax.swing.JApplet;
import javax.swing.JButton;

public class MMRPWRDemo extends JApplet implements ActionListener 
{
    // The Demo frame.
    MMRPWRFrame frame;

    // The buttons.
    JButton start;

    public void init() {
        start = new JButton("Run MMRPWR");
        this.setBackground(Color.white);
        this.getContentPane().setLayout(new GridLayout(1, 1));
        this.getContentPane().add(start);
        start.addActionListener(this);
    }

    // Handle button clicks here.
    public void actionPerformed(ActionEvent e) {
        if(frame == null) {
            frame = new MMRPWRFrame();
            Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
            Dimension frameSize = frame.getSize();
            if(frameSize.height > screenSize.height) {
                frameSize.height = screenSize.height;
            }
            if(frameSize.width > screenSize.width) {
                frameSize.width = screenSize.width;
            }
            frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
            frame.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    System.exit(0);
                }
            });
            frame.setVisible(true);
        }
    }

    // Make sure that the frame is disposed when the browser loads another page.
    public void stop() {
        if(frame != null) {
            frame.setVisible(false);
            frame.dispose();
            frame = null;
        }
    }
}



