package mmrpwr;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.Rectangle;
import java.awt.Font;
import java.awt.Color;
import java.awt.event.*;
import java.text.NumberFormat;
import java.util.ArrayList;
import javax.swing.*;


public class MMRPWRFrame extends JFrame implements ActionListener {

    private JLabel lblTitle = new JLabel();
    private JLabel lblCorrelation1 = new JLabel();
    private JTextField txtCorrelation1 = new JTextField();
    private JLabel lblCorrelation2 = new JLabel();
    private JTextField txtCorrelation2 = new JTextField();
    private JLabel lblCorrelation3 = new JLabel();
    private JTextField txtCorrelation3 = new JTextField();
    private JLabel lblSample1 = new JLabel();
    private JTextField txtSample1 = new JTextField();
    private JLabel lblSample2 = new JLabel();
    private JTextField txtSample2 = new JTextField();
    private JLabel lblStdSample = new JLabel();
    private JTextField txtStdSample = new JTextField();
    private JLabel lblStdPop = new JLabel();
    private JTextField txtStdPop = new JTextField();
    private JLabel lblResult = new JLabel();
    private JTextArea txtResult = new JTextArea();
    private JButton btnOK = new JButton();
    private JButton btnExit = new JButton();
    private JButton btnClear = new JButton();
    private JButton btnPrint = new JButton();

    private double corr1, corr2, corr3, stdSample, stdPop, sample1, sample2, power, lci, uci;


    public static void main(String[] args) {
        MMRPWRFrame frame = new MMRPWRFrame();
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setTitle("MMR Power Frame");
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        frame.setLocation((d.width - frameSize.width) / 2, (d.height - frameSize.height) / 2);
        frame.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    System.exit(0);
                }
            });
        frame.setVisible(true);

    }

    public MMRPWRFrame() {
        this.getContentPane().setLayout(null);
        this.getContentPane().setBackground(Color.white);
        this.setSize(new Dimension(650, 600));
        this.setTitle("Estimated Statistical Power Using MMR");

        lblTitle.setText("Enter the following values");
        lblTitle.setBounds(new Rectangle(179, 0, 240, 20));
        lblTitle.setFont(new Font("Dialog", 1, 14));

        lblCorrelation1.setText("Correlation Between Predictor X and Criterion Y for GROUP 1");
        lblCorrelation1.setBounds(new Rectangle(10, 30, 410, 20));
        txtCorrelation1.setText("");
        txtCorrelation1.setBounds(new Rectangle(400, 30, 100, 20));

        lblCorrelation2.setText("Correlation Between Predictor X and Criterion Y for GROUP 2");
        lblCorrelation2.setBounds(new Rectangle(10, 60, 410, 20));
        txtCorrelation2.setText("");
        txtCorrelation2.setBounds(new Rectangle(400, 60, 100, 20));

        lblCorrelation3.setText("Correlation Between Predictors X and Z for the Complete Sample");
        lblCorrelation3.setBounds(new Rectangle(10, 90, 430, 20));
        txtCorrelation3.setText("");
        txtCorrelation3.setBounds(new Rectangle(400, 90, 100, 20));

        lblSample1.setText("Sample Size for GROUP 1");
        lblSample1.setBounds(new Rectangle(10, 120, 360, 20));
        txtSample1.setText("");
        txtSample1.setBounds(new Rectangle(400, 120, 100, 20));

        lblSample2.setText("Sample Size for GROUP 2");
        lblSample2.setBounds(new Rectangle(10, 150, 360, 20));
        txtSample2.setText("");
        txtSample2.setBounds(new Rectangle(400, 150, 100, 20));

        lblStdSample.setText("Standard Deviation for Predictor X in the Sample");
        lblStdSample.setBounds(new Rectangle(10, 180, 360, 20));
        txtStdSample.setText("");
        txtStdSample.setBounds(new Rectangle(400, 180, 100, 20));

        lblStdPop.setText("Standard Deviation for Predictor X in the Population");
        lblStdPop.setBounds(new Rectangle(10, 210, 360, 20));
        txtStdPop.setText("");
        txtStdPop.setBounds(new Rectangle(400, 210, 100, 20));

        lblResult.setText("Estimated Power");
        lblResult.setBounds(new Rectangle(10, 290, 290, 20));
        lblResult.setForeground(new Color(158, 0, 0));
        lblResult.setFont(new Font("Dialog", 1, 12));

        txtResult.setText("");
        txtResult.setFont(new Font("Dialog", 1, 12));
        txtResult.setBounds(new Rectangle(10, 325, 470, 180));
        //txtResult.setBorder(BorderFactory.createMatteBorder(1, 3, 1, 1, Color.darkGray));
        txtResult.setEditable(false);

        btnOK.setText("OK");
        btnOK.setBounds(new Rectangle(50, 260, 85, 25));
        btnOK.setFont(new Font("Dialog", 1, 12));
        btnOK.setActionCommand("OK");
        btnOK.addActionListener(this);

        btnExit.setText("Exit");
        btnExit.setBounds(new Rectangle(150, 260, 85, 25));
        btnExit.setFont(new Font("Dialog", 1, 12));
        btnExit.setActionCommand("Exit");
        btnExit.addActionListener(this);

        btnClear.setText("Clear");
        btnClear.setBounds(new Rectangle(250, 260, 85, 25));
        btnClear.setFont(new Font("Dialog", 1, 12));
        btnClear.setActionCommand("Clear");
        btnClear.addActionListener(this);

        btnPrint.setText("Print Results");
        btnPrint.setBounds(new Rectangle(350, 260, 120, 25));
        btnPrint.setActionCommand("Print");
        btnPrint.addActionListener(this);


        this.getContentPane().add(lblTitle, null);
        this.getContentPane().add(lblCorrelation1, null);
        this.getContentPane().add(txtCorrelation1, null);
        this.getContentPane().add(lblCorrelation2, null);
        this.getContentPane().add(txtCorrelation2, null);
        this.getContentPane().add(lblCorrelation3, null);
        this.getContentPane().add(txtCorrelation3, null);
        this.getContentPane().add(lblSample1, null);
        this.getContentPane().add(txtSample1, null);
        this.getContentPane().add(lblSample2, null);
        this.getContentPane().add(txtSample2, null);
        this.getContentPane().add(lblStdSample, null);
        this.getContentPane().add(txtStdSample, null);
        this.getContentPane().add(lblStdPop, null);
        this.getContentPane().add(txtStdPop, null);
        this.getContentPane().add(lblResult, null);
        this.getContentPane().add(txtResult, null);
        this.getContentPane().add(btnOK, null);
        this.getContentPane().add(btnExit, null);
        this.getContentPane().add(btnClear, null);
        this.getContentPane().add(btnPrint, null);

    }

    public void actionPerformed(ActionEvent e) {
        if(e.getActionCommand().equals("OK")) {
            if(validateInput() == true) {
                estimatePower();
            }
        }
        else if(e.getActionCommand().equals("Exit")) {
            this.hide();
            this.dispose();
        }
        else if(e.getActionCommand().equals("Clear")) {
            txtCorrelation1.setText("");
            txtCorrelation2.setText("");
            txtCorrelation3.setText("");
            txtSample1.setText("");
            txtSample2.setText("");
            txtStdSample.setText("");
            txtStdPop.setText("");
            txtResult.setText("");
        }
        else if(e.getActionCommand().equals("Print")){
                               
            Component c = (java.awt.Component) txtResult;
	    PrintUtil.printComponent(c);
            

        }
    }

    /**
     * Prompts the user to provide all required input values.
     * @return  <code>true</code> if all the appropriate input is provided;
     * <code>false</code> if any field is empty inapprriate.
     */

    private boolean validateInput() {
        if((txtCorrelation1.getText().equals("") || txtCorrelation2.getText().equals("")
                || txtCorrelation3.getText().equals("")
                || txtSample1.getText().equals("") || txtSample2.getText().equals(""))
                || txtStdSample.getText().equals("") || txtStdPop.getText().equals("")) {
            JOptionPane.showMessageDialog(null, "Please provide all values.", "Alert", JOptionPane.ERROR_MESSAGE);
            return false;
        }
        else {
            try {
                this.corr1 = Double.parseDouble(txtCorrelation1.getText());
                this.corr2 = Double.parseDouble(txtCorrelation2.getText());
                this.corr3 = Double.parseDouble(txtCorrelation3.getText());
                this.sample1 = Double.parseDouble(txtSample1.getText());
                this.sample2 = Double.parseDouble(txtSample2.getText());
                this.stdSample = Double.parseDouble(txtStdSample.getText());
                this.stdPop = Double.parseDouble(txtStdPop.getText());

                if((corr1 >= 1 || corr1 <= -1)) {
                    JOptionPane.showMessageDialog(null,
                            "Correlation values must be between (+ 1 to -1). Ex: 0.4 ",
                            "Alert",
                            JOptionPane.ERROR_MESSAGE);
                    txtCorrelation1.setText("");
                    txtCorrelation1.requestFocus();
                    return false;
                }

                if((corr2 >= 1 || corr2 <= -1)) {
                    JOptionPane.showMessageDialog(null,
                            "Correlation values must be between (+ 1 to -1). Ex: 0.4 ",
                            "Alert",
                            JOptionPane.ERROR_MESSAGE);
                    txtCorrelation2.setText("");
                    txtCorrelation2.requestFocus();
                    return false;
                }

                if((corr3 >= 1 || corr3 <= -1)) {
                    JOptionPane.showMessageDialog(null,
                            "Correlation values must be between (+ 1 to -1). Ex: 0.4 ",
                            "Alert",
                            JOptionPane.ERROR_MESSAGE);
                    txtCorrelation3.setText("");
                    txtCorrelation3.requestFocus();
                    return false;
                }

                if((sample1 >= 0 && sample1 < 1)) {
                    JOptionPane.showMessageDialog(null,
                            "Sample size must be whole number greater than or equal to 1.",
                            "Alert",
                            JOptionPane.ERROR_MESSAGE);
                    txtSample1.setText("");
                    txtSample1.requestFocus();
                    return false;
                }
                if((sample2 >= 0 && sample2 < 1)) {
                    JOptionPane.showMessageDialog(null,
                            "Sample size must be whole number greater than or equal to 1.",
                            "Alert",
                            JOptionPane.ERROR_MESSAGE);
                    txtSample2.setText("");
                    txtSample2.requestFocus();
                    return false;
                }
            }
            catch(NumberFormatException nfe) {
                JOptionPane.showMessageDialog(null,
                        "Only numbers are allowed. Please verify the input values.",
                        "Alert",
                        JOptionPane.ERROR_MESSAGE);

                return false;
            }
            catch(Exception e) {
                e.printStackTrace();
            }
        }
        return true;
    }

    /**
     * Takes the values from the user and performs the statistical estimation.
     */
    private void estimatePower() {
        double fishz1, fishz2, fishz3,zd, rr, p1, n, estpower, ubnd, lbnd;
        double rrzd, rrn, rrfishz3, rrp1, nzd, zdp1, zdfishz3, np1, fishz3p1;

        fishz1 = 0.5 * Math.log((1.0 + corr1) / (1.0 - corr1));
        fishz2 = 0.5 * Math.log((1.0 + corr2) / (1.0 - corr2));
        zd = Math.abs(fishz1 - fishz2);
        fishz3 = 0.5 * Math.log((1 + corr3) / (1 - corr3));
        rr = stdSample / stdPop;
        n = sample1 + sample2;
        p1 = sample1 / n;

        // Centering predictors
        zd = zd - 0.398;
        fishz3 = fishz3 - 0.575;
        rr = rr - 0.6;
        n = n - 180.0;
        p1 = p1 - 0.3;

        // Computing 2-way product terms
        rrzd = rr * zd;
        rrn = rr * n;
        rrfishz3 = rr * fishz3;
        rrp1 = rr * p1;
        nzd = n * zd;
        zdp1 = zd * p1;
        zdfishz3 = zd * fishz3;
        np1 = n * p1;

        fishz3p1 = fishz3 * p1;

        estpower = 1.082 + (.5338 * rr) + (.0025 * n) + (.9708 * p1) + (.0317 * fishz3)
                + (1.6527 * zd) + (1.212 * rrzd) + (.001 * rrn)
                - (.102 * rrfishz3) + (.166 * rrp1) + (.006 * nzd)
                + (2.3 * zdp1) + (.087 * zdfishz3) + (.002 * np1) + (.178 * fishz3p1);

        this.power = (Math.sin(estpower / 2)) * (Math.sin(estpower / 2));

        ubnd = estpower + (.186 * 1.96);
        lbnd = estpower - (.186 * 1.96);
        this.lci = (Math.sin(lbnd / 2)) * (Math.sin(lbnd / 2));
        this.uci = (Math.sin(ubnd / 2)) * (Math.sin(ubnd / 2));

        if(power >= 1) power = 1;
        if(power < 0) power = 0;

        if(lci >= 1) lci = 1;
        if(lci < 0) lci = 0;

        if(uci >= 1) uci = 1;
        if(uci < 0) uci = 0;

        NumberFormat df = NumberFormat.getInstance();
        df.setMaximumFractionDigits(2);
        df.setMinimumFractionDigits(2);
     
	
        txtResult.setText("");
        txtResult.append("  Correlation Between Predictor X and Criterion Y for GROUP 1  :   " + df.format(corr1) + "\n");
        txtResult.append("  Correlation Between Predictor X and Criterion Y for GROUP 2  :   " + df.format(corr2) + "\n");
        txtResult.append("  Correlation Between Predictors X and Z for the Complete Sample  :   " + df.format(corr3) + "\n");

	    df.setMaximumFractionDigits(0);
	    txtResult.append("  Sample size for Subgroup 1  :   " + df.format(sample1) + "\n");
        txtResult.append("  Sample size for subgroup 2  :   " + df.format(sample2) + "\n");

	    df.setMaximumFractionDigits(2);
        df.setMinimumFractionDigits(2);
        txtResult.append("  Standard Deviation for Predictor X in the Sample  :   " + df.format(stdSample) + "\n");
        txtResult.append("  Standard Deviation for Predictor X in the Population  :   " + df.format(stdPop) + "\n");
        txtResult.append("\n");

	    NumberFormat nf = NumberFormat.getInstance();
	    nf.setMaximumFractionDigits(4);
        nf.setMinimumFractionDigits(4);
               
        txtResult.append("  Estimated Statistical Power  :   " + nf.format(power) + "\n");
        txtResult.append("  95% CI  :   " + nf.format(lci) + " to " + nf.format(uci));

    }

}

